.486
.model flat, stdcall
option casemap: none

; API functions
; ------------------------------------------------------------------------------
include  \masm32\include\windows.inc
include  \masm32\include\user32.inc
include  \masm32\include\kernel32.inc
include  \masm32\include\comctl32.inc
include  \masm32\include\masm32.inc

includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\comctl32.lib
includelib  \masm32\lib\masm32.lib
; ------------------------------------------------------------------------------

; Prototype 
; ------------------------------------------------------------------------------
DialogProc    PROTO : HWND, : UINT, : WPARAM, : LPARAM
Autotyperproc PROTO : HWND
.const

; Resource ids
; ------------------------------------------------------------------------------
IDD_DLG1  		equ 101
IDC_EDT1        equ 102
IDI_ICON        equ 200
; Required data

.data
szTitle       db 'Autotyping Example', 0

msg         db 'This is an autotyping example.',13,10
            db 'by Finding the window handle!',0

.data?
hInstance HINSTANCE ?
hIcon     HICON     ?
hEdit            dd ?

.code

start:
INVOKE GetModuleHandle, NULL
mov hInstance, eax

INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax
INVOKE InitCommonControls
; ---------------------------------------------
;   Call the dialog box stored in resource file
; ---------------------------------------------
INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, 0
INVOKE ExitProcess, 0


; Dialog procedure
; ------------------------------------------------------------------------------
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM

 .IF uMsg == WM_INITDIALOG
 
  INVOKE SetWindowText, hWnd, addr szTitle 
  INVOKE SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon
  INVOKE GetDlgItem,hWnd,102
   mov   hEdit,eax
  INVOKE Autotyperproc,hWnd
  
    .ELSEIF uMsg == WM_COMMAND
    .ELSEIF uMsg == WM_CLOSE
    INVOKE EndDialog, hWnd, 0
 .ENDIF

    xor eax,eax
  ret
DialogProc endp
Autotyperproc proc hWnd: HWND



    mov     edx,OFFSET msg
@@:
    xor     eax,eax
    mov     al,byte PTR [edx]
    or      al,al
    jz      @f
    push    edx
    invoke  SendMessage,hEdit,WM_CHAR,eax,0
    invoke  Sleep,200
    pop     edx
    inc edx
    jmp @b
@@:
 xor eax,eax
 	ret

Autotyperproc endp   
end start